-- automatically generated by BNF Converter
module Main where

import IO ( stdin,stderr,hPutStr, hGetContents )
import System ( getArgs, getProgName )
import System
import List (partition, (\\))

import Extract.Lex
import Extract.Par
import Extract.Skel
import Extract.Print
import Extract.Abs
import Extract.ErrM

import Paradigm
import Translate

main :: IO ()
main = do
  xs    <- getArgs
  case check_options xs of
   Ok _ ->
    if (elem "-h" xs) then do prErr welcome
                              prErr help_message
     else 
      do
       let (opts,fs) = partition ((=='-') . head) xs
       case fs of
        [parafile,corpus] -> do
         result <- get_paradigms parafile (elem "-utf8" xs)
	 case result of
	  Bad s  -> do prErr welcome
                       prErr s
          Ok  ps -> do prErr welcome
                       ffind opts ps corpus parafile
        _ -> do prErr welcome
                prErr help_message
   Bad s -> do prErr welcome
               prErr s

welcome :: String
welcome = unlines
	    [
	     "",
	     "********************************************",
	     "*           Lexicon Extraction             *", 
             "*                 with                     *",
             "*           Constraint Grammar             *",
	     "********************************************",
	     "* (c) Markus Forsberg & Aarne Ranta 2007   *",
	     "* under GNU General Public License.        *",
	     "********************************************"
	    ]

help_message :: String
help_message =
    unlines 
    [" Help message:                                   ",
     " extract [Option(s)] rule_file  corpus_file      ", 
     " Options:                                        ",
     "  -h       Display this message                  ",
     "  -utf8    Use UTF-8 encoding                    ",
     "  -nobad   Keep only the analysed words          ",
     "  -uncap   Transform uppercase to lowercase      ",
     "  -nocap   Remove all words in uppercase         ",
     "  -e       Print evidence as comment             ",
     "  -u       Print no duplicates                   ",
     "  -id      Print identifier                      ",
     "  -r       Reverse words                         "
    ]

check_options xs = case filter (\s -> head s == '-') (xs \\ options) of
		    [] -> return ()
		    xs -> Bad $ "Invalid options: " ++ unwords xs

options = ["-utf8","-h", "-nosymb", "-uncap", "-nobad", "-e", "-u","-id", "-r"]

prErr s =  hPutStr stderr (s ++ "\n")
